-- name: [CS] Morgana
-- description: [CS] Morgana from Persona 5
-- deluxe: true

if SM64COOPDX_VERSION == nil then
    local first = false
    hook_event(HOOK_ON_LEVEL_INIT, function()
        if not first then
            first = true
            play_sound(SOUND_MENU_CAMERA_BUZZ, gMarioStates[0].marioObj.header.gfx.cameraToObject)
            djui_chat_message_create("\\#ffa0a0\\Extra Characters is not supported with sm64ex-coop\nas it uses sm64coopdx exclusive Lua functionality.\n\\#dcdcdc\\To play this mod, try out sm64coopdx at\n\\#7f7fff\\https://sm64coopdx.com")
        end
    end)
    return
end
if not _G.charSelectExists then
    local first = false
    hook_event(HOOK_ON_LEVEL_INIT, function()
        if not first then
            first = true
            play_sound(SOUND_MENU_CAMERA_BUZZ, gGlobalSoundSource)
            djui_chat_message_create("\\#ffffa0\\Extra Characters requires Character Select to be enabled.\nPlease rehost with it enabled.")
        end
    end)
    return
end

local E_MODEL_MONA = smlua_model_util_get_id("mona_geo")

local TEX_MONA = get_texture_info("mona_icon")

local CAPTABLE_MONA = {
    normal = smlua_model_util_get_id("mona_cap_geo"),
    wing = smlua_model_util_get_id("mona_wing_cap_geo"),
    metal = smlua_model_util_get_id("mona_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("mona_metal_wing_cap_geo"),
}
_G.charSelect.character_add_caps(E_MODEL_MONA,CAPTABLE_MONA)

local VOICETABLE_MONAJP = {
    [CHAR_SOUND_ATTACKED] = {"Mona_Hit1JP.ogg", "Mona_Hit2JP.ogg", "Mona_Hit3JP.ogg", "Mona_Hit4JP.ogg", "Mona_Hit5JP.ogg", "Mona_Hit6JP.ogg", "Mona_Hit7JP.ogg"},
    [CHAR_SOUND_GROUND_POUND_WAH] = "Mona_GPJP.ogg",
    [CHAR_SOUND_HAHA] = "Mona_Haha1JP.ogg",
    [CHAR_SOUND_HAHA_2] = "Mona_Haha2JP.ogg",
    [CHAR_SOUND_HERE_WE_GO] = {"Mona_HereWeGo1JP.ogg", "Mona_HereWeGo2JP.ogg", "Mona_HereWeGo3JP.ogg"},
    [CHAR_SOUND_HOOHOO] = "Mona_HohoJP.ogg",
    [CHAR_SOUND_ON_FIRE] = "Mona_BurnJP.ogg",
    [CHAR_SOUND_OOOF] = {"Mona_Hit1JP.ogg", "Mona_Hit2JP.ogg", "Mona_Hit3JP.ogg", "Mona_Hit4JP.ogg", "Mona_Hit5JP.ogg", "Mona_Hit6JP.ogg", "Mona_Hit7JP.ogg"},
    [CHAR_SOUND_OOOF2] = {"Mona_Hit1JP.ogg", "Mona_Hit2JP.ogg", "Mona_Hit3JP.ogg", "Mona_Hit4JP.ogg", "Mona_Hit5JP.ogg", "Mona_Hit6JP.ogg", "Mona_Hit7JP.ogg"},
    [CHAR_SOUND_PUNCH_HOO] = "Mona_Punch3JP.ogg",
    [CHAR_SOUND_PUNCH_WAH] = "Mona_Punch2JP.ogg",
    [CHAR_SOUND_PUNCH_YAH] = "Mona_Punch1JP.ogg",
    [CHAR_SOUND_SO_LONGA_BOWSER] = {"Mona_Throw1JP.ogg", "Mona_Throw2JP.ogg", "Mona_Throw3JP.ogg"},
    [CHAR_SOUND_TWIRL_BOUNCE] = {"Mona_Punch3JP.ogg", "Mona_Punch2JP.ogg", "Mona_Punch1JP.ogg"},
    [CHAR_SOUND_WAAAOOOW] = "Mona_Hit1JP.ogg",
    [CHAR_SOUND_WAH2] = {"Mona_Jump1EN.ogg", "Mona_Jump2JP.ogg"},
    [CHAR_SOUND_WHOA] = "Mona_WoahJP.ogg",
    [CHAR_SOUND_YAHOO] = "Mona_Punch3JP.ogg",
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {"Mona_Punch3JP.ogg", "Mona_Punch2JP.ogg", "Mona_Punch1JP.ogg"},
    [CHAR_SOUND_YAH_WAH_HOO] = {"Mona_Jump1JP.ogg", "Mona_Jump2JP.ogg", "Mona_Punch1JP.ogg"},
    [CHAR_SOUND_OKEY_DOKEY] = {"Mona_OkeyDokey1JP.ogg", "Mona_OkeyDokey2JP.ogg", "Mona_OkeyDokey3JP.ogg", "Mona_OkeyDokey4JP.ogg"},
    [CHAR_SOUND_LETS_A_GO] = {"Mona_LetsGo1JP.ogg", "Mona_LetsGo2JP.ogg"},
    [CHAR_SOUND_DYING] = {"Mona_Die1JP.ogg", "Mona_Die2JP.ogg", "Mona_Die3JP.ogg"},
    [CHAR_SOUND_DROWNING] = "Curley_Drown.ogg",
    [CHAR_SOUND_EEUH] = {"Mona_Pickup1JP.ogg", "Mona_Pickup2JP.ogg"},
    [CHAR_SOUND_MAMA_MIA] = {"Mona_MamaMia1JP.ogg", "Mona_MamaMia2JP.ogg", "Mona_MamaMia3JP.ogg", "Mona_MamaMia4JP.ogg", "Mona_MamaMia5JP.ogg"},
    [CHAR_SOUND_DOH] = {"Mona_Hit1JP.ogg", "Mona_Hit2JP.ogg", "Mona_Hit3JP.ogg", "Mona_Hit4JP.ogg", "Mona_Hit5JP.ogg", "Mona_Hit6JP.ogg", "Mona_Hit7JP.ogg"},
    [CHAR_SOUND_HRMM] = {"Mona_Pickup1JP.ogg", "Mona_Pickup2JP.ogg"},
    [CHAR_SOUND_PANTING] = {"Mona_Pant1JP.ogg", "Mona_Pant2JP.ogg"},
	[CHAR_SOUND_PANTING_COLD] = "Mona_PantColdJP.ogg",
    [CHAR_SOUND_UH] = {"Mona_Hit1JP.ogg", "Mona_Hit2JP.ogg", "Mona_Hit3JP.ogg", "Mona_Hit4JP.ogg", "Mona_Hit5JP.ogg", "Mona_Hit6JP.ogg", "Mona_Hit7JP.ogg"},
	[CHAR_SOUND_GAME_OVER] = "Mona_GameOverJP.ogg",
	[CHAR_SOUND_YAWNING] = "Mona_YawnJP.ogg"
}
local VOICETABLE_MONAEN = {
    [CHAR_SOUND_ATTACKED] = {"Mona_Hit1EN.ogg", "Mona_Hit2EN.ogg", "Mona_Hit3EN.ogg", "Mona_Hit4EN.ogg", "Mona_Hit5EN.ogg", "Mona_Hit6EN.ogg", "Mona_Hit7EN.ogg"},
    [CHAR_SOUND_GROUND_POUND_WAH] = "Mona_GPEN.ogg",
    [CHAR_SOUND_HAHA] = "Mona_Haha1EN.ogg",
    [CHAR_SOUND_HAHA_2] = "Mona_Haha2EN.ogg",
    [CHAR_SOUND_HERE_WE_GO] = {"Mona_HereWeGo1EN.ogg", "Mona_HereWeGo2EN.ogg", "Mona_HereWeGo3EN.ogg"},
    [CHAR_SOUND_HOOHOO] = "Mona_HohoEN.ogg",
    [CHAR_SOUND_ON_FIRE] = "Mona_BurnEN.ogg",
    [CHAR_SOUND_OOOF] = {"Mona_Hit1EN.ogg", "Mona_Hit2EN.ogg", "Mona_Hit3EN.ogg", "Mona_Hit4EN.ogg", "Mona_Hit5EN.ogg", "Mona_Hit6EN.ogg", "Mona_Hit7EN.ogg"},
    [CHAR_SOUND_OOOF2] = {"Mona_Hit1EN.ogg", "Mona_Hit2EN.ogg", "Mona_Hit3EN.ogg", "Mona_Hit4EN.ogg", "Mona_Hit5EN.ogg", "Mona_Hit6EN.ogg", "Mona_Hit7EN.ogg"},
    [CHAR_SOUND_PUNCH_HOO] = "Mona_Punch3EN.ogg",
    [CHAR_SOUND_PUNCH_WAH] = "Mona_Punch2EN.ogg",
    [CHAR_SOUND_PUNCH_YAH] = "Mona_Punch1EN.ogg",
    [CHAR_SOUND_SO_LONGA_BOWSER] = {"Mona_Throw1EN.ogg", "Mona_Throw2EN.ogg", "Mona_Throw3EN.ogg"},
    [CHAR_SOUND_TWIRL_BOUNCE] = {"Mona_Punch3EN.ogg", "Mona_Punch2EN.ogg", "Mona_Punch1EN.ogg"},
    [CHAR_SOUND_WAAAOOOW] = "Mona_Hit1EN.ogg",
    [CHAR_SOUND_WAH2] = {"Mona_Jump1EN.ogg", "Mona_Jump2EN.ogg"},
    [CHAR_SOUND_WHOA] = "Mona_WoahEN.ogg",
    [CHAR_SOUND_YAHOO] = "Mona_Punch3EN.ogg",
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {"Mona_Punch3EN.ogg", "Mona_Punch2EN.ogg", "Mona_Punch1EN.ogg"},
    [CHAR_SOUND_YAH_WAH_HOO] = {"Mona_Jump1EN.ogg", "Mona_Jump2EN.ogg", "Mona_Punch1EN.ogg"},
    [CHAR_SOUND_OKEY_DOKEY] = {"Mona_OkeyDokey1EN.ogg", "Mona_OkeyDokey2EN.ogg", "Mona_OkeyDokey3EN.ogg", "Mona_OkeyDokey4EN.ogg"},
    [CHAR_SOUND_LETS_A_GO] = {"Mona_LetsGo1EN.ogg", "Mona_LetsGo2EN.ogg"},
    [CHAR_SOUND_DYING] = {"Mona_Die1EN.ogg", "Mona_Die2EN.ogg", "Mona_Die3EN.ogg"},
    [CHAR_SOUND_DROWNING] = "Curley_Drown.ogg",
    [CHAR_SOUND_EEUH] = {"Mona_Pickup1EN.ogg", "Mona_Pickup2EN.ogg"},
    [CHAR_SOUND_MAMA_MIA] = {"Mona_MamaMia1EN.ogg", "Mona_MamaMia2EN.ogg", "Mona_MamaMia3EN.ogg", "Mona_MamaMia4EN.ogg", "Mona_MamaMia5EN.ogg"},
    [CHAR_SOUND_DOH] = {"Mona_Hit1EN.ogg", "Mona_Hit2EN.ogg", "Mona_Hit3EN.ogg", "Mona_Hit4EN.ogg", "Mona_Hit5EN.ogg", "Mona_Hit6EN.ogg", "Mona_Hit7EN.ogg"},
    [CHAR_SOUND_HRMM] = {"Mona_Pickup1EN.ogg", "Mona_Pickup2EN.ogg"},
    [CHAR_SOUND_PANTING] = {"Mona_Pant1EN.ogg", "Mona_Pant2EN.ogg"},
	[CHAR_SOUND_PANTING_COLD] = "Mona_PantColdEN.ogg",
    [CHAR_SOUND_UH] = {"Mona_Hit1EN.ogg", "Mona_Hit2EN.ogg", "Mona_Hit3EN.ogg", "Mona_Hit4EN.ogg", "Mona_Hit5EN.ogg", "Mona_Hit6EN.ogg", "Mona_Hit7EN.ogg"},
	[CHAR_SOUND_GAME_OVER] = "Mona_GameOverEN.ogg",
	[CHAR_SOUND_YAWNING] = "Mona_YawnEN.ogg"
}

_G.charSelect.character_add("Morgana", {"Stupid cat who debuted in", "Persona 5"}, "Knola", { r = 245, g = 200, b = 0 }, E_MODEL_MONA, CT_MARIO, TEX_MONA)

_G.charSelect.character_add_voice(E_MODEL_MONA, VOICETABLE_MONAJP)

function on_monaen_command(msg)
    if msg == 'on' then
        djui_chat_message_create('Morgana English Voice: On')
		_G.charSelect.character_add_voice(E_MODEL_MONA, VOICETABLE_MONAEN)
        return true
    elseif msg == 'off' then
        djui_chat_message_create('Morgana English Voice: Off')
		_G.charSelect.character_add_voice(E_MODEL_MONA, VOICETABLE_MONAJP)
        return true
	elseif msg == null then
		djui_chat_message_create("[on|off] turn Morgana's English voice on or off")
		return false
    end
    return false
end

local hasBooted = false
function monaboot()
	djui_chat_message_create('Morgana has an English voice toggle: /monaen on')
end
hook_chat_command('monaen', "[on|off] turn Morgana's English voice on or off", on_monaen_command)

hook_event(HOOK_MARIO_UPDATE, function (m)
	if(hasBooted == false) then
		monaboot()
		hasBooted = true
	end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_MONAJP then _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_MONAEN then _G.charSelect.voice.snore(m) end
end)
hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
    if _G.charSelect.character_get_voice(m) == VOICETABLE_MONAJP then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_MONAEN then return _G.charSelect.voice.sound(m, sound) end
end)